//M1 Garand, Weapon_M1Gar.cs

//Audioblocks
//m1shotSound
//m1clipoutSound
//m1clipinSound
//m1clipslideSound
datablock AudioProfile(m1shotSound)
{
   filename    = "./Sounds/m1shot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(m1clipoutSound)
{
   filename    = "./Sounds/m1clipout.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(m1clipinSound)
{
   filename    = "./Sounds/m1clipin.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ExplosionData(m1MeleeExplosion : hammerExplosion)
{
	soundProfile = hammerHitSound;
	uiName = "";
};

AddDamageType("M1Gar",   '<bitmap:add-ons/Weapon_M1Gar/CI_m1> %1',    '%2 <bitmap:add-ons/Weapon_M1Gar/CI_m1> %1',0.2,1);
AddDamageType("M1GarMel",   '<bitmap:base/client/ui/ci/generic> %1',    '%2 <bitmap:base/client/ui/ci/generic> %1',0.2,1);
datablock ProjectileData(m1projectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 63;
   directDamageType    = $DamageType::M1Gar;
   radiusDamageType    = $DamageType::M1Gar;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 35;
   verticalImpulse	  = 2;
   explosion           = GunExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 185;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 3000;
   fadeDelay           = 2500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.4;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "M1 Bullet";
};
datablock ProjectileData(m1Meleeprojectile)
{
   directDamage        = 40;
   directDamageType  = $DamageType::M1Mel;
   radiusDamageType  = $DamageType::M1Mel;
   explosion           = m1MeleeExplosion;

   muzzleVelocity      = 30;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   
   uiName = "";
};

//////////
// item //
//////////
datablock ItemData(m1Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Models/m1final.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "M1 Garand";
	iconName = "./icon_m1";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = m1Image;
	canDrop = true;
	
	//Ammo Guns Parameters
	maxAmmo = 8;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(m1Image)
{
   // Basic Item properties
   shapeFile = "./Models/m1final.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = m1Item;
   ammo = " ";
   projectile = m1projectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1 -0.8 2";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 10.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = m1Item.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   //  NAMES   | FUNCTIONS
   // use      | pull gun out
   // fire     | shoot
   // clipout  | clip flys out
   // clipin   | put clip in
   
   // Initial start up state - Ammo mod by Space Guy.
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.01;
	stateSequence[0]			= "Use";
	stateTransitionOnTimeout[0]     = "LoadCheckE1";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "ClipOut";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 0.2;
	stateTransitionOnTimeout[2]     = "Smoke";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "fire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= gunflashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= m1shotSound;
	stateEjectShell[2]              = true;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateTimeoutValue[3]	= 0.03;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTimeout[3]	= "LoadCheckA";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.1;
	stateTransitionOnTriggerUp[4] = "Ready";
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "Wait";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "ClipOut";
	stateWaitForTimeout[7]			= true;
	//Reloading
	stateName[8]				= "ClipOut";
	stateTimeoutValue[8]			= 0.15;
	stateScript[8]				= "onReloadStart";
	stateSequence[8]		= "clipOut";
	stateAllowImageChange[8]        = false;
	stateTransitionOnTimeout[8]		= "ClipIn";
	stateWaitForTimeout[8]			= true;
	stateSound[8]				= m1clipOutSound;
	
	stateName[9]				= "ClipIn";
	stateTimeoutValue[9]			= 1.8;
	stateScript[9]				= "";
	stateSequence[9]		= "clipIn";
	stateAllowImageChange[9]        = false;
	stateTransitionOnTimeout[9]		= "reloadFinish";
	
	stateName[10]				= "reloadFinish";
	stateTimeoutValue[10]			= 0.1;
	stateScript[10]				= "onReloaded";
	stateAllowImageChange[10]        = false;
	stateSound[10]				= m1clipInSound;
	stateTransitionOnTimeout[10]		= "Ready";
		
	stateName[11]				= "ReadyWeap";
	stateTimeoutValue[11] 			= 0.2;
	stateTransitionOnTimeout[11]		= "Ready";
	
	stateName[12]				= "LoadCheckE";
	stateTransitionOnAmmo[12]		= "ReadyWeap";
	stateTransitionOnNoAmmo[12]		= "ReloadWait";
	
	stateName[13]				= "LoadCheckE1";
	stateScript[13]				= "onLoadCheck";
	stateTimeoutValue[13]			= 0.00000001;
	stateTransitionOnTimeout[13]		= "LoadCheckE";
};

datablock ShapeBaseImageData(m1SightsImage)
{
   shapeFile = "./Models/m1final.dts";
   emap = true;

   mountPoint = 0;
   offset = "-0.5 0 0.2"; //-Left +Right, -Back +Front, -Down +Up
   eyeOffset = "-0.007 1.5 -0.50"; //-Left +Right, -Back +Front, -Down +Up
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = m1Item;
   ammo = " ";
   projectile = m1projectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1 -0.8 2";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 10.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = m1Item.colorShiftColor;
   
	stateName[0]                    = "Activate";
	stateSequence[0]			= "Use";
	stateTimeoutValue[0]            = 0.01;
	stateTransitionOnTimeout[0]     = "LoadCheckE1";

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "reloadSequence";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTimeoutValue[2]            = 0.2;
	stateTransitionOnTimeout[2]     = "Smoke";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "fire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= gunflashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= m1shotSound;
	stateEjectShell[2]              = true;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateTimeoutValue[3]		= 0.03;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTimeout[3] = "LoadCheckA";

	stateName[4]			= "Wait";
	stateTimeoutValue[4]		= 0.1;
	stateTransitionOnTriggerUp[4]	= "Ready";
	
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "Wait";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "reloadSequence";
	stateWaitForTimeout[7]			= true;
	
	stateName[8]				= "reloadSequence";
	stateScript[8]				= "setm1ReN";
	
	stateName[9]				= "ReadyWeap";
	stateTimeoutValue[9] 			= 0.05;
	stateTransitionOnTimeout[9]		= "Ready";
	
	stateName[10]				= "LoadCheckE";
	stateTransitionOnAmmo[10]		= "ReadyWeap";
	stateTransitionOnNoAmmo[10]		= "ReloadWait";
	
	stateName[11]				= "LoadCheckE1";
	stateScript[11]				= "onLoadCheck";
	stateTimeoutValue[11]			= 0.00000001;
	stateTransitionOnTimeout[11]		= "LoadCheckE";
};

function m1SpawnProj(%this,%obj,%slot,%type)
{
	if(%obj.isImageMounted(m1Image) && vectorLen(%obj.getVelocity()) < 1)
		%spread = 0.00009;
	else if(%obj.isImageMounted(m1Image) && vectorLen(%obj.getVelocity()) > 1)
		%spread = 0.0004;

	if(%type $= "m1Meleeprojectile")
		%spread = 0.000001;
	
	%projectile = %type;
	
	%obj.lastShotTime = getSimTime();
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	return %p;
}
function m1SightsImage::setm1ReN(%this,%obj,%slot)
{
	%obj.mountImage(m1Image, 0);
	%obj.toolAmmo[%obj.currTool] = 0;
}
function m1SightsImage::onFire(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		m1SpawnProj(%this,%obj,%slot,m1projectile);
		%obj.toolAmmo[%obj.currTool]--;
	}
	else if(%this.item.maxAmmo == 0)
		m1SpawnProj(%this,%obj,%slot,m1projectile);
}
function m1Image::onFire(%this,%obj,%slot)
{
	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
		m1SpawnProj(%this,%obj,%slot,m1projectile);
		%obj.toolAmmo[%obj.currTool]--;
	}
	else if(%this.item.maxAmmo == 0)
		m1SpawnProj(%this,%obj,%slot,m1projectile);
}

function m1Image::onReloadStart(%this,%obj,%slot,%projectile)
{
	%obj.toolAmmo[%obj.currTool] = 0;
}

function m1Image::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.setImageAmmo(%slot,1);
}

package m1Package //Melee and Irons
{
	function armor::onTrigger(%this, %obj, %triggerNum, %val)
	{
		%client = %obj.client;		
		if(%triggerNum == 4 && %obj.isImageMounted(m1Image) && %val && %obj.toolAmmo[%obj.currTool] != 0) //Irons
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(m1SightsImage, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
		}
		else if(%triggerNum == 4 && %obj.isImageMounted(m1SightsImage) && %val)
		{
			%newAmmo = %obj.toolAmmo[%obj.currTool];
			%obj.mountImage(m1Image, 0);
			%obj.toolAmmo[%obj.currTool] = %newAmmo;
		}
		Parent::onTrigger(%this, %obj, %triggerNum, %val);
	}
	function serverCmdCancelBrick(%client)
	{
		%obj = %client.player;
		if(%obj.isImageMounted(m1Image) && %obj.lastHitTime - getSimTime() < 1000 && %obj.toolAmmo[%obj.currTool] > 0)
		{
			%obj.playThread(0,shiftAway);
			m1SpawnProj(m1Image,%obj,0,m1Meleeprojectile);
		}
		%obj.lastHitTime = getSimTime();
		parent::serverCmdCancelBrick(%client);
	}
};
activatePackage(m1Package);

function m1Image::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.hideNode("RHand");
	%obj.hideNode("RHook");
	%obj.hideNode("LHand");
	%obj.hideNode("LHook");
}

function m1Image::onUnMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
		applyDefaultCharacterPrefs(%obj);
}

function m1SightsImage::onMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.hideNode("RHand");
	%obj.hideNode("RHook");
	%obj.hideNode("LHand");
	%obj.hideNode("LHook");
}

function m1SightsImage::onUnMount(%this,%obj,%slot)
{
	Parent::onMount(%this,%obj,%slot);
	%obj.unHideNode("ALL");
	if(isObject(%obj.client))
	{
		%obj.client.applyBodyParts();
		%obj.client.applyBodyColors();
	}
	else
		applyDefaultCharacterPrefs(%obj);
}